(function(window) {

	var u = {};
	//
	u.reDownloadAppCount = 10;
	u.insertTotal = 400;
	// 当前frame上打开的子frame
	var openedFrameSet = new Array();
	// 头部高度
	var headerHeight = 52;
	// 正常frame区域
	var frameRect = {
		x : 0,
		y : headerHeight,
		w : 'auto',
		h : 'auto'
	};
	// 全屏frame区域
	var fullFrameRect = {
		x : 0,
		y : 0,
		w : 'auto',
		h : 'auto'
	};
	// 头部标签区域，其他值动态生成
	var headerLabelRect = {
		y : 0,
		h : headerHeight
	};
	// 是否是Android
	var isAndroid = (/android/gi).test(navigator.appVersion);
	// 本地存储
	function uzStorage() {
		var ls = window.localStorage;
		if (isAndroid) {
			ls = os.localStorage();
		}
		return ls;
	}

   // json转字符串
	u.jsonToStr = function(json) {
		if ( typeof json === 'object') {
			return JSON && JSON.stringify(json);
		}
	};
	// 字符串转json
	u.strToJson = function(str) {
		if ( typeof str === 'string') {
			return JSON && JSON.parse(str);
		}
	};
	// 本地存储-存储
	// json对象会转成字符串存储，读取时会自动转成json格式
	u.setStorage = function(key, value) {
		if (arguments.length === 2) {
			var v = value;
			if ( typeof v == 'object') {
				v = JSON.stringify(v);
				v = 'obj-' + v;
			} else {
				v = 'str-' + v;
			}
			var ls = uzStorage();
			if (ls) {
				ls.setItem(key, v);
			}
		}
	};
	// 本地存储-读取
	// json对象会转成字符串存储，读取时会自动转成json格式
	u.getStorage = function(key) {
		var ls = uzStorage();
		if (ls) {
			var v = ls.getItem(key);
			if (!v) {
				return;
			}
			if (v.indexOf('obj-') === 0) {
				v = v.slice(4);
				return JSON.parse(v);
			} else if (v.indexOf('str-') === 0) {
				return v.slice(4);
			}
		}
	};
	// 本地存储-移除
	u.rmStorage = function(key) {
		var ls = uzStorage();
		if (ls && key) {
			ls.removeItem(key);
		}
	};
	// 本地存储-清除
	u.clearStorage = function() {
		var userSearchAll = $common.getStorage("userSearchAll");
		if(null!=curAccount&&undefined!=curAccount&&null!=curAccount.id &&undefined!=curAccount.id &&null!=userSearchAll&&undefined!=userSearchAll){
			var userSearch = $common.getStorage("user"+curAccount.id );
			if(userSearch!=null&&userSearch!=undefined&&userSearch.accountId!=undefined){
				for(var i=0;i<userSearchAll.length;i++){
				if(userSearchAll[i].accountId
				==userSearch.accountId){
				userSearchAll.splice(i,1);
				break;
				}
			}
			}
			userSearchAll.push(userSearch);
		}
		var ls = uzStorage();
		if (ls) {
			ls.clear();
		}
		$common.setStorage("userSearchAll",userSearchAll);
	};

	// 退出应用
	u.exit = function(params) {
		if (!params) {
			params = {};
		}
		// 如果不是静默退出，调用自己的对话框
		if (!params.silent) {
			 if(confirm("确认要退出程序吗?")){
				api.closeWidget({"silent":true});
	    	 }	
		} else {
			api.closeWidget(params);
		}
		var rtcApi = api.require('tyRTC');
		rtcApi.logout();
		var ajpush = api.require('ajpush');
		ajpush.bindAliasAndTags({
			alias : "tags"
		}, function(ret) {
			
		});
	};
	// 打开frame
	u.openFrame = function(params) {
		openedFrameSet.push(params.name);

		var type = params.type;
		if (type === 'full') {
			params.rect = fullFrameRect;
			params.bgColor = 'rgba(0, 0, 0, 0.17)';
			api.lockSlidPane();
		} else if (type === 'header_label') {
			headerLabelRect.w = params.width;
			headerLabelRect.x = (api.winWidth - headerLabelRect.w) / 2;
			params.rect = headerLabelRect;
		} else if (type === 'frame') {
			params.rect = frameRect;
		}

		if (params.reload !== false) {
			params.reload = true;
		}

		if (!params.pageParam) {
			params.pageParam = {};
		}
		
		params.animation = {
		    type:"push",                //动画类型（详见动画类型常量）
		    duration: 150                //动画过渡时间，默认300毫秒
		}
		api.openFrame(params);
	};
	// 关闭frame
	u.closeFrame = function(params) {
		if (!params) {
			params = {};
		}
		api.sendEvent({
			name : 'close_frame',
			extra : {
				name : params.name || api.frameName,
				unlockSlidPane : params.unlockSlidPane
			}
		});
	};
	// 打开win
	u.openWin = function(params) {
		if (params.reload !== false) {
			params.reload = true;
		}
		if (!params.animation) {
			params.animation = {
				type : 'suck'
			};
		}
		if (api.systemType == "ios") {
			params.slidBackEnabled = true;
		}
		params.animation = {
		    type:"push",                //动画类型（详见动画类型常量）
		    duration: 200                //动画过渡时间，默认300毫秒
		}
		api.openWin(params);
	};
	// 关闭win
	u.closeWin = function(name) {
		api.closeWin({
			name : name,
			animation : {
			    type:"push",                //动画类型（详见动画类型常量）
			    subType:"from_left",       //动画子类型（详见动画子类型常量）
			    duration: 150                //动画过渡时间，默认300毫秒
			}
		});
	};
	// 关闭到指定win
	u.closeToWin = function(name) {
		api.closeToWin({
			name : name,
			animation : {
				type : 'none'
			}
		});
	};
	// 打开frameGroup
	u.openFrameGroup = function(params, callback) {
		if (!params.rect) {
			params.rect = {
				x : 0,
				y : 0,
				w : 'auto',
				h : 'auto'
			};
		}
		var frames = params.frames;
		var length = frames.length;
		if (!params.preload) {
			params.preload = length - 1;
		}
		for (var i = 0; i < length; i++) {
			frames[i].vScrollBarEnabled = false;
			frames[i].hScrollBarEnabled = false;
			frames[i].bounces = false;
		}
		api.openFrameGroup(params, callback);
	};
	// 关闭当前frame所打开的所有frame
	// 参数为忽略的frame
	u.closeAllChildren = function(ignoreFrameName) {
		if (ignoreFrameName) {
			var index = openedFrameSet.indexOf(ignoreFrameName);
			if (index >= 0) {
				openedFrameSet.splice(index, 1);
			}
		}
		var length = openedFrameSet.length;
		for (var i = 0; i < length; i++) {
			this.closeFrame({
				name : openedFrameSet[i]
			});
		}
		openedFrameSet = new Array();
	};
	// 显示进度提示框
	u.showProgress = function(params) {
		api.showProgress(params);
	};
	// 隐藏进度提示框
	u.hideProgress = function() {
		api.hideProgress();
	};

	u.toast = function(params) {
		api.toast(params);
	};

	// 按键声音
	u.createMedia = function(fileName) {
		if (fileName) {
			api.startPlay({
				path: fileName
			}, function(ret, err) {
			});
		}
	}
	
	u.createApiUrl = function(url) {
		return 'http://' + u.getStorage('server_ip') + '/istore_service/api/' + url;
	};

	u.createStaticUrl = function(url) {
		return 'http://' + u.getStorage('server_ip') + '/istore_service/static/' + url;
	};
	
	window.$common = u;

	var apireadyEvent = document.createEvent('HTMLEvents');
	apireadyEvent.initEvent('apiready', false, false);

	var closeEvent = document.createEvent('HTMLEvents');
	closeEvent.initEvent('close_frame', false, false);

	window.apiready = function() {
		window.dispatchEvent(apireadyEvent);
	}

	window.addEventListener('apiready', function() {
		// 返回键 退出
//		api.addEventListener({
//			name : 'keyback'
//		}, function(ret, err) {
//			$common.exit();
//		});
		var ci = 0;
		var time1, time2;
		api.addEventListener({
			name : 'keyback'
		}, function(ret, err) {
			if (ci == 0) {
				time1 = new Date().getTime();
				ci = 1;
				api.toast({
					msg : '再按一次返回键退出'
				});
			} else if (ci == 1) {
				time2 = new Date().getTime();
				if (time2 - time1 < 2000) {
					try {
						var ajpush = api.require('ajpush');
						ajpush.bindAliasAndTags({
							alias : "tags"
						}, function(ret) {
							
						});
					} catch(e) {
					
					}
					api.closeWidget({
						id : api.appId,
						retData : {
							name : 'closeWidget'
						},
						silent : true
					});
					
					$common.rmStorage("folderId");
				} else {
					ci = 0;
					api.toast({
						msg : '再按一次返回键退出'
					});
				}
			}
		});

		// tap 键盘输入结束
		api.addEventListener({
			name : 'tap'
		}, function(ret, err) {
			api.sendEvent({
				name : 'input_over'
			});
		});
		// 关闭Frame事件
		api.addEventListener({
			name : 'close_frame'
		}, function(ret, err) {
			if (ret && ret.value && ret.value.name) {
				var name = ret.value.name;
				var unlockSlidPane = ret.value.unlockSlidPane;
				if (unlockSlidPane !== false) {
					api.unlockSlidPane();
				}
				if (api.frameName && name == api.frameName) {
					window.dispatchEvent(closeEvent);
				}
			}
		});
	});

	window.addEventListener('close_frame', function() {
		$common.closeAllChildren();
		api.setFrameAttr({
			hidden : true
		});
	});

})(window);
	
//var url = "http://192.168.1.147:8080/MSMS"
var url = "http://www.medtechshare.com/MSMS"

///////////////推送///////////////////
function jPush(userId) {
	var systemType = api.systemType;  // 比如： ios
	var param = {
		alias : userId
	};
	var ajpush = api.require('ajpush');
	ajpush.setBadge({
	    badge:0
	});
	if (systemType == "android") {
		ajpush.init(function(ret) {
			if (ret && ret.status == 1) {//初始化成功
				api.addEventListener({name:'resume'}, function(ret,err) {
				    ajpush.onResume();
				});
				api.addEventListener({name:'pause'}, function(ret,err) {
				    ajpush.onPause();
				});
				ajpush.onPause();
				ajpush.bindAliasAndTags(param, function(ret) {
					api.addEventListener({
					    name: 'appintent'
					}, function(ret, err) {
					    if (ret && ret.appParam.ajpush) {
					        var extra = ret.appParam.ajpush.extra;
					        if (extra.flg == "live") {//跳转到直播详情页
								$common.openWin({
							          name: 'liveInfo',
							          url: 'widget://html/liveInfo.html',
							          pageParam: {
							          	  id : extra.liveVideoid
							          }
							    });
							} else if(extra.flg == 'publishVideo'){//关注的医生发布视频审核通过
								window.$common.openWin({
								  	name: 'videoInfo',
								 	url: 'widget://html/videoInfo.html',
								 	pageParam: {
								  	  id : extra.videoid
								  	}
						 		});
							}
					    }
					});
				});
			}
		});
	} else if (systemType == "ios") {
		ajpush.bindAliasAndTags(param,function(ret) {
			api.addEventListener({
			    name: 'noticeclicked'
			}, function(ret, err) {
				ajpush.setBadge({
				    badge:0
				});
				if (ret && ret.value) {
			    	var extra = ret.value.extra;
			        if (extra.flg == "live") {//跳转到直播详情页
						$common.openWin({
					          name: 'liveInfo',
					          url: 'widget://html/liveInfo.html',
					          pageParam: {
					          	  id : extra.liveVideoid
					          }
					    });
					} else if(extra.flg == 'publishVideo'){//关注的医生发布视频审核通过
						window.$common.openWin({
						  	name: 'videoInfo',
						 	url: 'widget://html/videoInfo.html',
						 	pageParam: {
						  	  id : extra.videoid
						  	}
				 		});
					}
			    }
			});
			ajpush.setListener(
			    function(ret) {
			    	if (ret) {
			         	var title = ret.title;
		         		var content = ret.content;
		         		var extra = ""
		         		if (null != ret.extra) {
		         			extra = {extra: ret.extra};
		         		}
		    			api.notification({
						    notify: {
						    	title: title,
						        content: content,
						        extra: extra
						    }
						});
						ajpush.setBadge({
						    badge:0
						});
			    	}
			    }
			);
		});
	}
}
///////////////推送///////////////////

/**
 * 获取动态权限，使用功能
 * @param {Object} authName 权限名称
 * @param {Object} msg 提示消息
 * @param {Object} callback 使用功能
 */
function getAuth (authList, msg, callback) {
    if(api.systemType == 'ios'){
    	if (callback) {
    		callback();
    	}
    }else{
		var resultList = api.hasPermission({
		    list: authList
		});
		if (null != resultList) {
			var reqList = [];
			for (var i = 0; i < resultList.length; i++) {
				var json = resultList[i];
				if (!json["granted"]) {
					reqList.push(json["name"]);
				}
			}
			if (reqList.length > 0) {
				api.requestPermission({
				    list:reqList,
				    code:1
				}, function(ret, err){
					var goOn = true;
				    if (ret && ret["list"]) {
				    	var list = ret["list"];
				    	for (var i = 0; i < list.length; i++) {
							var json = list[i];
							if (!json["granted"] && authList.indexOf(json["name"]) != -1) {
								goOn = false;
							}
						}
				    }
				    if (!goOn) {
				    	api.toast({
		                    msg: "请开启" + msg + "权限"
		                });
				    } else {
				    	if (callback) {
				    		callback();
				    	}
				    }
				});
			} else {
				if (callback) {
		    		callback();
		    	}
			}
		}
    }
}

//用户未登录
function gotoLogin(){
	var infoLogin = $api.getStorage("jsonObj");
 	if(!infoLogin){
		$common.openWin({
	        name: 'login',
	        url: 'login.html',
	        reload:true
	    });
	 	return false;
 	}
 	return true;
}
