//获取验证码
var uuid = "";
function createImageCode(id) {  //验证码id
    var checkCode = document.getElementById(id);
    if (checkCode){
	    $.ajax({
			type : "post",
			url : url + "/code/getImageCode",
			data : {},
			dataType : "JSON",
			type : "get",
			async : false,
			success : function(data) {
				if (data.success) {
					checkCode.className = "verification";
			        checkCode.innerHTML = data.imageCode.code;
			        uuid = data.imageCode.uuid;
				}
			}
		});
    }
}


/**
 * 手机号发送验证码
 * @param mobile  手机号
 * @param type  类型1、注册 2、找回密码 3、修改手机号 4、邮箱注册 5、邮箱找回密码 6、修改邮箱
 * @param obj  jQuery对象
 * @param codeid  验证码输入框id
 * @returns
 */
var countdown = 60; 
function sendCode(mobile, type, obj, codeid) {
	var codeImage = $("#" + codeid).val();
	if(!codeImage){
		if(type != 2 && type != 5){
			alert("请输入图形校验");
		}else {
			alert("请输入图形校验");
		}
		$("#" + codeid).focus();
		return false;
	}
	if(obj){
		sendCodeSettime(obj)
	}
	$.ajax({
		type : "post",
		url : url+"/code/sendCode",
		dataType : "JSON",
		type : "post",
		async : true,
		data : {mobile : mobile, type : type, codeImage: codeImage, uuid: uuid},
		success : function(data) {
			if(data.success){
				alert("发送成功");
			}else{
				alert(data.msg);
				if(data.msg == "图形验证码错误"){
					createImageCode(codeid + "_T");
					$("#" + codeid).focus();
				}
			}
		}
	});
}

function sendCodeSettime(obj) { //发送验证码倒计时
    if (countdown == 0) {
        obj.css("pointer-events","")
        obj.html("获取验证码");
        countdown = 60; 
        return;
    } else {
        obj.css("pointer-events","none")
        obj.html("重新发送(" + countdown + ")");
        countdown--; 
    } 
    setTimeout(function() {
    	sendCodeSettime(obj) 
    },1000) 
}

/**
 * 验证手机验证码
 * @param mobile  手机号
 * @param type  类型1、注册 2、找回密码 3、修改手机号 4、邮箱注册 5、邮箱找回密码 6、修改邮箱
 * @param code  验证码
 * @returns
 */
function checkCode(mobile, type, code){
	var isgo = false;
	$.ajax({
		type : "post",
		url : url+"/code/checkCode",
		dataType : "JSON",
		type : "post",
		async : false,
		data : {mobile: mobile, type: type, code: code},
		success : function(data) {
			if(data.success){
				isgo = true;
			}else{
				alert(data.msg);
				isgo =  false;
			}
		},error:function(){
			alert("验证失败");
			isgo =  false;
		}
	});
	return isgo;
}


//发送验证码
function sendYZM(mobile,regToken,obj){
	if(checkMobile){
		$.ajax({
			type : "post",
			url : url+"/yzm/sendYZM",
			dataType : "JSON",
			type : "post",
			async : true,
			data : {mobile : mobile,regToken : regToken},
			success : function(msg) {
				if(msg=="2"){
					//发送成功
					if(obj){
						sendYZMsuccess(obj);
					}
				}else{
					//发送失败
					if(obj){
						sendYZMfailed(obj);
					}
				}
			},error:function(){
				if(obj){
					sendYZMfailed(obj);
				}
			}
		});
	}
}
//发送验证码到邮箱
function sendYZMToEmail(email,obj){
	if(checkMobile){
		$.ajax({
			type : "post",
			url : url+"/yzm/sendYZMToEmail",
			dataType : "JSON",
			type : "post",
			async : true,
			data : {email : email},
			success : function(msg) {
				if(msg=="1"){
					//发送成功
					if(obj){
						sendYZMsuccess(obj);
					}
				}else{
					//发送失败
					if(obj){
						sendYZMfailed(obj);
					}
				}
			},error:function(){
				if(obj){
					sendYZMfailed(obj);
				}
			}
		});
	}
}
//验证手机验证码
function checkYZM(yanzhengma,mobile){
	if(checkMobile){
		var code = 0;
		$.ajax({
			type : "post",
			url : url+"/yzm/checkYZM",
			dataType : "JSON",
			type : "post",
			async : false,
			data : {yanzhengma : yanzhengma , mobile : mobile},
			success : function(msg) {
				code = msg;
			},error:function(){
				code = "0";
			}
		});
		if(code=="1"){
			//验证成功
			return true;
		}else{
			return false;
		}
	}
}

//验证email验证码
function checkEmailYZM(yanzhengma,email){
	if(checkMobile){
		var code = 0;
		$.ajax({
			type : "post",
			url : url+"/yzm/checkEmailYZM",
			dataType : "JSON",
			type : "post",
			async : false,
			data : {yanzhengma : yanzhengma , email : email},
			success : function(msg) {
				code = msg;
			},error:function(){
				code = "0";
			}
		});
		if(code=="1"){
			//验证成功
			return true;
		}else{
			return false;
		}
	}
}

//验证手机号
function checkMobile(mobile) {
    var zhi = mobile;
    var reg = "^1[3|4|5|8][0-9]\\d{8}$";
    var re = new RegExp(reg);
    if (re.test(zhi)) {
       //alert('正确');
        return true;
    }
    else {
    	promptInfo2("请输入正确的手机号！");
        return false;
    }
}
//发送验证码成功 把发送验证码按钮改成暂无发送倒计时60秒
var YZMInterval = null;
var YZMtime = 0;
function sendYZMsuccess(obj){
	if(YZMInterval == null){
		YZMInterval = setInterval(function(){
			var time = 60 - YZMtime;
			if(time == 30){
				$.ajax({
					type : "post",
					url : url+"/yzm/getRegToken",
					dataType : "text",
					type : "post",
					async : false,
					data : {},
					success : function(msg) {
						$("#regToken").val(msg);
					}
				});
			}
			var text = "已发送,"+time;
			obj.text(text);
			obj.attr('disabled',"true");
			if(YZMtime >= 60){
				obj.removeAttr("disabled");
				obj.text("发送验证码");
				YZMtime =0;
				clearInterval(YZMInterval);
				YZMInterval = null;
			}
			YZMtime++;
		},1000);
	}
}
//发送验证码失败 把发送验证码按钮改成暂无发送倒计时60秒
function sendYZMfailed(obj){
	if(YZMInterval == null){
		YZMInterval = setInterval(function(){
			var time = 60 - YZMtime;
			if(time == 30){
				$.ajax({
					type : "post",
					url : url+"/yzm/getRegToken",
					dataType : "text",
					type : "post",
					async : false,
					data : {},
					success : function(msg) {
						$("#regToken").val(msg);
					}
				});
			}
			var text = "发送失败,"+time;
			obj.text(text);
			obj.attr('disabled',"true");
			if(YZMtime >= 60){
				obj.removeAttr("disabled");
				obj.text("发送验证码");
				YZMtime =0;
				clearInterval(YZMInterval);
				YZMInterval = null;
			}
			YZMtime++;
		},1000);
	}
}
