//去除字符串两边的空格
String.prototype.trim = function () {
    return this.replace(/(^\s+)|(\s+$)/g, "");
}

//检测字符串是否为空
String.prototype.isEmpty = function () {
	if(this==null || !(/.?[^\s　]+/.test(this))){
		
		return true;
	}
	
	return false;
}

/**
 * 正则表达式验证：
 * /^[a-zA-Z0-9_\-]+$/			英文数字下划线
 * /^[\u0391-\uFFE5]+$/			必须输入汉字
 * /^[-\+]?\d+(\.\d+)?$/		number
 * /^[-\+]?\d+$/				integer
 * /^[-\+]?\d+(\.\d+)?$/		float
 * /^(\d{4})(-|\/)(\d{1,2})\2(\d{1,2})$/	日期
 * /^\w+([-+.]\w+)*@\w+([-.]\w+)*\.\w+([-.]\w+)*$/ email
 * /^(((ht|f)tp(s?))\:\/\/)[a-zA-Z0-9]+\.[a-zA-Z0-9]+[\/=\?%\-&_~`@[\]\':+!]*([^<>\"\"])*$/  url
 * /^(0|[1-9]\d?|[0-1]\d{2}|2[0-4]\d|25[0-5]).(0|[1-9]\d?|[0-1]\d{2}|2[0-4]\d|25[0-5]).(0|[1-9]\d?|[0-1]\d{2}|2[0-4]\d|25[0-5]).(0|[1-9]\d?|[0-1]\d{2}|2[0-4]\d|25[0-5])$/	ip地址
 * /^[1-9]\d{5}$/	邮编
 * /^([0-1]{1}\d|2[0-3]):([0-5]\d)$/    小时:分钟
 */
String.prototype.regTest=function(reg){
	
	if(this.isEmpty() || this.match(reg)){
		
		return true;
	}
	
	return false;
}


function promptInfo(info){
	var outTime = 1000;
	$("#showInfoDiv").html('<font color="#fff">'+info+'</font>');
	$(".alert-box").fadeIn('slow',function(){
		setTimeout(function(){ 
			$(".alert-box").fadeOut('slow');
		}, outTime);
	});
	
}	
	
var codeLogin, codeRegister, codeForgetPassword;
function createCode(type) {
	var codeLength = 4;// 验证码的长度
	var code = "";  //验证码
	codeLogin = ""; 
	codeRegister = "";
	codeForgetPassword = "";
	var checkCode = "";
	if (type == 1) { // 登录
		checkCode = document.getElementById("checkCodeLogin");
	} else if (type == 2) { // 注册
		checkCode = document.getElementById("checkCodeRegister");
	} else if (type == 3) { // 注册
		checkCode = document.getElementById("checkCodeRegister2");
	} else { // 忘记密码
		checkCode = document.getElementById("checkCodeForgetPwd");
	}
	if(checkCode == null){
		createCode(type);
		return false;
	}
	checkCode.value = "";
	var selectChar = new Array(1, 2, 3, 4, 5, 6, 7, 8, 9, 'a', 'b', 'c', 'd',
			'e', 'f', 'g', 'h', 'j', 'k', 'l', 'm', 'n', 'p', 'q', 'r', 's',
			't', 'u', 'v', 'w', 'x', 'y', 'z', 'A', 'B', 'C', 'D', 'E', 'F',
			'G', 'H', 'J', 'K', 'L', 'M', 'N', 'P', 'Q', 'R', 'S', 'T', 'U',
			'V', 'W', 'X', 'Y', 'Z');

	for ( var i = 0; i < codeLength; i++) {
		var charIndex = Math.floor(Math.random() * 60);
		code += selectChar[charIndex];
	}
	if (code.length != codeLength) {
		createCode(type);
		return false;
	}
	
    var num1 = Math.floor(1 + Math.random() * (255 - 1));
    var num2 = Math.floor(1 + Math.random() * (255 - 1));
    var num3 = Math.floor(1 + Math.random() * (255 - 1));
    
    checkCode.style.color  = '#'+('00000'+(Math.random()*0x1000000<<0).toString(16)).slice(-6);
    if (num1 == 0 && num2 == 0 && num3 == 0) {
		checkCode.style.color = "white";
	}
	if (num1 == 255 && num2 == 255 && num3 == 255) {
		checkCode.style.color = "black";
	}
    checkCode.style.background =  "rgba("+num1+", "+num2+", "+num3+" , 0.3)";
	checkCode.value = code;
	
	if (type == 1) { // 登录
		codeLogin = code; 
	} else if (type == 2) { // 注册
		codeRegister = code; 
	} else { // 忘记密码
		codeForgetPassword = code;
	}
}
    

 

